//Copyright 2010 mindstormsguy@verizon.net
/******************************************************************
		This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**********************************************************************/

//Includes
#include <tigcclib.h>

//Sprites
//Just an X, feel free to substitute your own "mole"
unsigned short int mole[] = {0x8001, 0x4002, 0x2004, 0x1008, 0x0810, 0x0420, 0x0240, 0x0180, 0x0180, 0x0240, 0x0420, 0x0810, 0x1008, 0x2004, 0x4002, 0x8001};

//Functions
//If ESC, always exit
short int getkey() {
	short key = ngetchx();
	if (key == KEY_ESC)
		exit(0);
	else
		return key;
}

void _main(void) {
	//Clear the Screen
	ClrScr();
	//Welcome Message and Lines
	DrawStr(0, 0, "Welcome to Whac-a-Mole!", A_NORMAL);
	//Each square is 29 pixels
	//Horizontal Lines
	DrawLine(35, 39, 124, 39, A_NORMAL);
	DrawLine(35, 69, 124, 69, A_NORMAL);
	//Vertical Lines
	DrawLine(64, 10, 64, 99, A_NORMAL);
	DrawLine(94, 10, 94, 99, A_NORMAL);
	short int row;
	short int column;
	short int score = 0;
	getkey();
	DrawStr(0, 0, "Go!                   ", A_REPLACE);
	//Setup and start timer
	OSFreeTimer (USER_TIMER);
	OSRegisterTimer (USER_TIMER, 15*20);
	while (!OSTimerExpired (USER_TIMER)) {
		//Note that "Row" means horizontal position
		//"Column" means vertical position
		//Randomly choose position and draw to screen
		row = rand() % 3;
		column = rand() % 3;
		Sprite16(43+(row*30), 18+(column*30), 16, mole, LCD_MEM, SPRT_OR);
		//Keep on waiting for key press until it is correct
		do {} while (getkey() - 48 != row + 1 + 3*(2 - column));
		score++;
		//Then XOR sprite in, erasing original
		Sprite16(43+(row*30), 18+(column*30), 16, mole, LCD_MEM, SPRT_XOR);
	}
	//Tell the user their score
	char* scorestring [20];
	sprintf(scorestring, "You had a score of %d!   ", score);
	DrawStr(0, 0, scorestring, A_REPLACE);
	ngetchx();
}